// ===========================================================================
//
// sexypsf for PSP
// Copyright (C) 2005 Weltall
// Copyright (C) 2005 Sumire Kinoshita
//
// 0.4.5-r1 (13/7/2005)
// 0.4.5-1.1 (27/9/2005)
// 0.4.5-1.1b (2/10/2005)
// 0.4.5-1.1c (4/11/2005)
//   - եȥ꡼
//
// ===========================================================================

#include <pspkernel.h>
#include <pspthreadman.h>
#include <psppower.h>
#include <pspctrl.h>
#include <pspaudio.h>
#include <pspdebug.h>
#include <psphprm.h>
#include <stdio.h>
#include <stdarg.h>
#include <string.h>
#define _SPSF_TYPES_H__
#include <driver.h>
#include <psprtc.h>
#include <stdlib.h>
#include <time.h>
#include <pspsdk.h>

// ===========================================================================
//
// ޥ
//
// ===========================================================================

// ⥸塼̾   : sexypsf
// ⥸塼° : ̵
// С     : 0.1
PSP_MODULE_INFO("sexypsf", 0x1000, 0, 1);

// å° : 桼⡼ / VFPU ͭ
PSP_MAIN_THREAD_ATTR(THREAD_ATTR_USER | THREAD_ATTR_VFPU);

#define MAX_ENTRY 1024 // ե
#define MAX_PATH  1024 // ե̾

#define SAMPLE_COUNT PSP_AUDIO_SAMPLE_ALIGN(1024) // ֥åΥץ
#define SAMPLE_SIZE  (SAMPLE_COUNT * 4)           // ֥åΥХȿ
#define BUFFER_COUNT 8                            // ХåեθĿ
#define BUFFER_SIZE  (SAMPLE_SIZE * 64)           // ХåեΥХȿ

// ===========================================================================
//
// Τ
//
// ===========================================================================

// 򼨤Ρ
enum {
	SCENE_DUMMY = 0,
	SCENE_FILER, // ե
	SCENE_PLAY   // ա
};

// ===========================================================================
//
// ѿ
//
// ===========================================================================

static int audio_thread_id;       // ǥåɤ ID
static u8 audio_thread_exit_flag; // ǥåɤνλե饰
static int sexy_thread_id;        // ߥ졼󥹥åɤ ID
static u8 sexy_thread_exit_flag;  // ߥ졼󥹥åɤνλե饰

static u8 sound_buffer[BUFFER_COUNT][BUFFER_SIZE]; // ɥХåե
static u8 sound_buffer_ready[BUFFER_COUNT];        // ɥХåեƤ뤫ե饰
static u8 sound_read_index;                        // ɥХåեɤ߹ߥǥå
static u32 sound_read_offset;                      // ɥХåեɤ߹ߥեåȡ
static u8 sound_write_index;                       // ɥХåեν񤭹ߥǥå
static u32 sound_write_offset;                     // ɥХåեν񤭹ߥեåȡ

static int current_scene;      // ߤΥ
static int filer_scene_index;  // ե̤ɽǥå
static int filer_scene_select; // ե̤򥤥ǥå

static PSFINFO *psf_info;               // PSFINFO ¤Ρ
static char current_psf_path[MAX_PATH]; // ߤ PSF եΥѥ

static char current_directory[MAX_PATH];       // ߤΥǥ쥯ȥꡣ
static SceIoDirent current_dirents[MAX_ENTRY]; // ߤΥǥ쥯ȥΥե
static int current_dirents_count;              // ߤΥǥ쥯ȥΥե

u8 enable_reverb; // С֤ͭ / ̵ե饰../spu/spu.c 껲Ȥ롣
int thread_paused = 0; //tells if the play and sexypsf thread are suspended
int enable_shuffle = 0; //suffle is enabled if 1
/*used to count play time*/
u64 start_cputicks = 0;
u64 current_tick = 0;
int seconds = 0;
int minutes = 0;
int hours = 0;

__attribute__ ((constructor))
void loaderInit()
{
    pspKernelSetKernelPC();
    pspSdkInstallNoDeviceCheckPatch();
	pspDebugInstallErrorHandler(NULL);
    //pspDebugInstallKprintfHandler(NULL);
}
// ===========================================================================
//
// ؿ
//
// ===========================================================================

// ---------------------------------------------------------------------------
// audio_thread
//
// ǥåɡ
//
//  :
//   args : ̤ѡ
//   argp : ̤ѡ
//
//  :
//    0
// ---------------------------------------------------------------------------
static int audio_thread(SceSize args, void *argp)
{
	int audio_handle; // ǥͥΥϥɥ롣
	
	// ǥͥμ
	audio_handle = sceAudioChReserve(
		PSP_AUDIO_NEXT_CHANNEL, SAMPLE_COUNT, PSP_AUDIO_FORMAT_STEREO);
	// åɤνλե饰ΩĤޤǥ롼ס
	while(!audio_thread_exit_flag)
	{
		// ȡ(10 ms)
		sceKernelDelayThread(10000);
		
		// оݥɥХåեޤԤġ
		if(!sound_buffer_ready[sound_read_index]) {
			continue;
		}
		
		// оݥɥХåե 1 ֥åʬϤ롣
		sceAudioOutputPannedBlocking(
			audio_handle, PSP_AUDIO_VOLUME_MAX, PSP_AUDIO_VOLUME_MAX,
			&sound_buffer[sound_read_index][sound_read_offset]);
		
		// ɤ߹ߥեåȤʤ롣
		sound_read_offset += SAMPLE_SIZE;
		
		// оݥɥХåեƽϤѤ
		if(sound_read_offset >= BUFFER_SIZE) {
			// ΥɥХåե򻲾Ȥ褦ڤؤ롣
			sound_buffer_ready[sound_read_index] = 0;
			sound_read_index++;
			sound_read_offset = 0;
			
			// ǸΥɥХåեã
			if(sound_read_index >= BUFFER_COUNT) {
				// ǽΥɥХåե򻲾Ȥ褦ڤؤ롣
				sound_read_index = 0;
			}
		}
	}
	
	// ̵Υ֥åϤ롣ΥץΥɻѡ
	sceAudioOutputPannedBlocking(audio_handle, 0, 0, sound_buffer[0]);
	
	// ǥͥβ
	sceAudioChRelease(audio_handle);
	
	// åɤνλ
	sceKernelExitThread(0);
	
	// ｪλ
	return 0;
}

// ---------------------------------------------------------------------------
// sexy_thread
//
// ߥ졼󥹥åɡ
//
//  :
//   args : ̤ѡ
//   argp : ̤ѡ
//
//  :
//    0
// ---------------------------------------------------------------------------
static int sexy_thread(SceSize args, void *argp)
{
	// ưå 333MHz ѹ
	scePowerSetClockFrequency(333, 333, 166);


	
	// ߥ졼󳫻ϡsexy_stop() ƤФޤʤ
	// ץ뤬줿 sexyd_update() ƤФ롣
	sexy_execute();
	
	// ưå 222MHz ѹ
	scePowerSetClockFrequency(222, 222, 111);

	
	// åɤνλ
	sceKernelExitThread(0);
	
	// ｪλ
	return 0;
}

// ---------------------------------------------------------------------------
// sexyd_update
//
// ߥ졼ǥץ뤬줿ƤФؿ
//
//  :
//   buffer : 줿ץ롣(44100 Hz / 16 bit / Stereo)
//   length : buffer ΥХȿ
//
//  :
//   ̵
// ---------------------------------------------------------------------------
void sexyd_update(u8 *buffer, int length)
{
	int buffer_free_length; // оݥХåեλĤꥵ
	
	// оݥɥХåեˤʤޤԤġ
	do
	{
		// ȡ(0.01 ms)
		sceKernelDelayThread(10);
		
		// åɤνλե饰ΩäƤ뤫
		if(sexy_thread_exit_flag) {
			// ߥ졼ߤ롣
			sexy_stop();
			// ｪλ
			return;
		}
		
next:;
	} while(sound_buffer_ready[sound_write_index]);
	
	// оݥХåեλĤꥵ׻롣
	buffer_free_length = BUFFER_SIZE - sound_write_offset;
	
	// оݥХåեƤΥץ񤭹뤫
	if(buffer_free_length >= length) {
		// оݥХåեƤΥץ񤭹ࡣ
		memcpy(&sound_buffer[sound_write_index][sound_write_offset], buffer, length);
		
		// 񤭹ߥեåȤʤ롣
		sound_write_offset += length;
	} else {
		// оݥХåեλĤꥵʬץ񤭹ࡣ
		memcpy(&sound_buffer[sound_write_index][sound_write_offset], buffer, buffer_free_length);
		
		// 񤭹ʬץΥХåեݥ󥿤ȥĴ롣
		buffer += buffer_free_length;
		length -= buffer_free_length;
		
		// ΥɥХåե򻲾Ȥ褦ڤؤ롣
		sound_buffer_ready[sound_write_index] = 1;
		sound_write_index++;
		sound_write_offset = 0;
		
		// ǸΥɥХåեã
		if(sound_write_index >= BUFFER_COUNT) {
			// ǽΥɥХåե򻲾Ȥ褦ڤؤ롣
			sound_write_index = 0;
		}
		
		// ĤΥץ񤭹िˡΥɥХåեˤʤΤԤġ
		goto next;
	}
}

// ---------------------------------------------------------------------------
// psf_play
//
// PSF եαճϡ
//
//  :
//   ̵
//
//  :
//    0ʳ -1
// ---------------------------------------------------------------------------
static int psf_play()
{
	int i; // ѿ
	thread_paused = 0;
	// PSF ɤ߹ߡ
	sceRtcGetCurrentTick(&start_cputicks);
	seconds = 0;
	minutes = 0;
	hours = 0;
	psf_info = sexy_load(current_psf_path);


	// PSFINFO ¤Τͭ
	if(psf_info) {
		// ɥХåեν
		for(i = 0; i < BUFFER_COUNT; i++)
		{
			memset(sound_buffer[i], 0, BUFFER_SIZE);
			sound_buffer_ready[i] = 0;
		}
		
		// ɥХåեɤ߽񤭥ǥå / եåȤν
		sound_read_index   = 0;
		sound_read_offset  = 0;
		sound_write_index  = 0;
		sound_write_offset = 0;
		
		// ǥåɤȳϡ
		audio_thread_id = sceKernelCreateThread("audio_thread", audio_thread, 18, 65536, 0, 0);
		audio_thread_exit_flag = 0;
		sceKernelStartThread(audio_thread_id, 0, 0);
		
		// ߥ졼󥹥åɤȳϡ
		sexy_thread_id = sceKernelCreateThread("sexy_thread", sexy_thread, 32, 65536, 0, 0);
		sexy_thread_exit_flag  = 0;
		sceKernelStartThread(sexy_thread_id, 0, 0);
		
		// ｪλ
		return 0;
	} else {
		// 顼λ
		return -1;
	}
}

// ---------------------------------------------------------------------------
// psf_stop
//
// PSF եαߡ
//
//  :
//   ̵
//
//  :
//   ̵
// ---------------------------------------------------------------------------
static void psf_stop()
{
	// PSFINFO ¤Τͭ
	if(thread_paused == 1)
		{
			scePowerSetCpuClockFrequency(333);
			scePowerSetBusClockFrequency(166);
			sceKernelResumeThread(sexy_thread_id);
			sceKernelResumeThread(audio_thread_id);
			//	printf_line(1,"unpaused");
			thread_paused = 0;
		}
	if(psf_info) {
		// ߥ졼󥹥åɤߤ˴
		sexy_thread_exit_flag = 1;
		sceKernelWaitThreadEnd(sexy_thread_id, 0);
		sceKernelDeleteThread(sexy_thread_id);
		
		// ǥåɤߤ˴
		audio_thread_exit_flag = 1;
		sceKernelWaitThreadEnd(audio_thread_id, 0);
		sceKernelDeleteThread(audio_thread_id);
		
		// PSFINFO ¤Τ˴
		sexy_freepsfinfo(psf_info);
		psf_info = 0;
		thread_paused = 0;

	}
}

// ---------------------------------------------------------------------------
// set_dirents
//
// ǥ쥯ȥμ
//
//  :
//   ̵
//
//  :
//    0ʳ -1
// ---------------------------------------------------------------------------
static int set_dirents()
{
	SceUID uid;         // ǥ쥯ȥꥨȥ ID
	SceIoDirent dirent; // Ѥ SceIoDirent
	char *extention;    // եγĥҤؤΥݥ󥿡
	int r;              // ѿ

	// ǥ쥯ȥꥨȥμ
	uid = sceIoDopen(current_directory);
	
	// ǥ쥯ȥꥨȥ̵꤬
	if(uid < 0) {
		// 顼λ
		return -1;
	}
	
	// եμ
	for(current_dirents_count = 0; current_dirents_count < MAX_ENTRY;)
	{
		// ʤ sceIoDread ե꡼롣
		memset(&dirent, 0, sizeof(SceIoDirent));
		
		// ȥɤ߹ߡ
		r = sceIoDread(uid, &dirent);
		
		// ǥ쥯ȥ꤫
		if(FIO_SO_ISDIR(dirent.d_stat.st_attr)) {
			// ȥ鸽ߤΥǥ쥯ȥإԡ
			memcpy(&current_dirents[current_dirents_count], &dirent, sizeof(SceIoDirent));
			
			// ߤΥǥ쥯ȥΥե򥤥󥯥ȡ
			current_dirents_count++;
		} else {
			// ե̾ĥҤФ
			extention = strrchr(dirent.d_name, '.');
			
			// ĥҤ¸ߤ뤫
			if(extention) {
				// ݡȤĥҤ
				if(!stricmp(extention, ".psf") || !stricmp(extention, ".psf1") || !stricmp(extention, ".minipsf")) {
					// ȥ鸽ߤΥǥ쥯ȥإԡ
					memcpy(&current_dirents[current_dirents_count], &dirent, sizeof(SceIoDirent));
					
					// ߤΥǥ쥯ȥΥե򥤥󥯥ȡ
					current_dirents_count++;
				}
			}
		}
		
		// ǸΥȥ꤫
		if(r <= 0) {
			break;
		}
	}
	
	// ǥ쥯ȥꥨȥβ
	sceIoDclose(uid);
	
	// ｪλ
	return 0;
}

// ---------------------------------------------------------------------------
// printf_line
//
// ԤФեޥåȺѤʸɽ
//
//  :
//   y      : Կ
//   format : եޥåʸ
//   ...    : եޥåȰ
//
//  :
//   ̵
// ---------------------------------------------------------------------------
static void printf_line(int y, char *format, ...)
{
	va_list options; // ФĹ
	char buffer[68]; // ʸѥХåե68  1 Ԥɽǽʸ
	int r;           // ѿ
	
	// ĹФ
	va_start(options, format);
	
	// եޥåȺѤʸ롣
	r = vsnprintf(buffer, 68, format, options);
	
	// եޥåȺѤʸ 68 ʸĶƤʤ
	if(r >= 0) {
		// Ĥäʬ򥹥ڡ롣
		memset(&buffer[r], ' ', 68 - r);
		
		// ߥ͡Ȥ롣
		buffer[67] = '\0';
	}
	
	// ֤ꤹ롣
	pspDebugScreenSetXY(0, y);
	
	// եޥåȺѤʸɽ롣
	pspDebugScreenPrintf(buffer);
}

// ---------------------------------------------------------------------------
// filer_draw
//
// ե̤ɽ
//
//  :
//   ̵
//
//  :
//   ̵
// ---------------------------------------------------------------------------
static void filer_draw()
{
	int i, j; // ѿ
	
	// ե̤ɽ
	printf_line(0, current_directory);
	printf_line(1, "===== File selector ===============================================");
	
	for(i = 2; i < 32; i++)
	{
		// եФ륤ǥå롣
		j = i - 2 + filer_scene_index;
		
		// ե뤬¸ߤ뤫
		if(j < current_dirents_count) {
			printf_line(i, "%s %s%s",
				// Υե뤬򤵤ƤʤСղá
				(j == filer_scene_select) ? ">" : " ",
				// ե̾
				current_dirents[j].d_name,
				// ǥ쥯ȥǤС˥ѥ졼ղá
				FIO_SO_ISDIR(current_dirents[j].d_stat.st_attr) ? "/" : ""
			);
		} else {
			// Ԥɽ
			printf_line(i, "");
		}
	}
	
	printf_line(32, "===================================================================");
	printf_line(33, "Cursor = Move / Circle = Play / Triangle = Toggle reverb        |%s|",
		// С֤ͭɤ󥸥
		enable_reverb ? "R" : " "
	);
}

// ---------------------------------------------------------------------------
// play_draw
//
// ղ̤ɽ
//
//  :
//   ̵
//
//  :
//   ̵
// ---------------------------------------------------------------------------
static void play_draw()
{
	int i; // ѿ
	
	// ղ̤ɽ
	printf_line( 0, current_dirents[filer_scene_select].d_name);
	printf_line( 1, "===== PSF information ===============================%s========", thread_paused ? "PAUSED" : "======");
//	printf_line( 1, "===== PSF information =============================================");
	printf_line( 2, "Game      : %s", psf_info->game      ? psf_info->game      : "");
	printf_line( 3, "Title     : %s", psf_info->title     ? psf_info->title     : "");
	printf_line( 4, "Artist    : %s", psf_info->artist    ? psf_info->artist    : "");
	printf_line( 5, "Year      : %s", psf_info->year      ? psf_info->year      : "");
	printf_line( 6, "Genre     : %s", psf_info->genre     ? psf_info->genre     : "");
	printf_line( 7, "PSF by    : %s", psf_info->psfby     ? psf_info->psfby     : "");
	printf_line( 8, "Copyright : %s", psf_info->copyright ? psf_info->copyright : "");
	
	for(i = 9; i < 31; i++)
	{
		// Ԥɽ
		printf_line(i, "");
	}
	printf_line(31, "%3d:%2d:%2d",hours,minutes,seconds);
	printf_line(32, "===================================================================");
	printf_line(33, "Cross = Stop / Triangle = Toggle reverb                       |%s|%s|",
		// С֤ͭɤ󥸥
		enable_shuffle ? "S" : " ",enable_reverb ? "R" : " "
	);
}

// ---------------------------------------------------------------------------
// filer_scene
//
// ե̤Υ롼׽
//
//  :
//   buttons : Ƥܥ
//
//  :
//   ̵
// ---------------------------------------------------------------------------
static void filer_scene(int buttons)
{
	int i; // ѿ
	
	// ܥ󤬲줿
	if(buttons & (PSP_CTRL_UP | PSP_CTRL_RIGHT | PSP_CTRL_DOWN | PSP_CTRL_LEFT)) {
		// ܥ˱ư̤롣
		if(buttons & PSP_CTRL_UP) {
			// 1 ǥåذư
			i = -1;
		} else if(buttons & PSP_CTRL_RIGHT) {
			// 10 ǥåذư
			i = 10;
		} else if(buttons & PSP_CTRL_DOWN) {
			// 1 ǥåذư
			i = 1;
		} else {
			// 10 ǥåذư
			i = -10;
		}
		
		// 򥤥ǥåư롣
		filer_scene_select += i;
		
		// 򥤥ǥåեƱ礭ʤä
		if(filer_scene_select >= current_dirents_count) {
			// 򥤥ǥå򥯥åפ롣
			filer_scene_select = current_dirents_count - 1;
		// 򥤥ǥå 0 꾮ʤä
		} else if(filer_scene_select < 0) {
			// 򥤥ǥå򥯥åפ롣
			filer_scene_select = 0;
		}
		
		// ɽǥå򥤥ǥå礭ʤä
		if(filer_scene_index > filer_scene_select) {
			// ɽǥåư롣
			filer_scene_index += i;
			
			// ɽǥå 0 꾮ʤä
			if(filer_scene_index < 0) {
				// ɽǥå򥯥åפ롣
				filer_scene_index = 0;
			}
		// ɽǥå + 30 򥤥ǥåƱʤä
		} else if(filer_scene_index + 30 <= filer_scene_select) {
			// ɽǥåư롣
			filer_scene_index += i;
			
			// ɽǥå + 30 եƱ礭ʤä
			if(filer_scene_index + 30 >= current_dirents_count) {
				// ɽǥå򥯥åפ롣
				filer_scene_index = current_dirents_count - 30;
			}
		}
		
		// ̤򹹿롣
		filer_draw();
	// ܥ󤬲줿
	} else if(buttons & PSP_CTRL_CIRCLE) {
		// ǥ쥯ȥ꤫
		if(FIO_SO_ISDIR(current_dirents[filer_scene_select].d_stat.st_attr)) {
			// ǥ쥯ȥ̾ 1 ХܤɥåȤ
			if(current_dirents[filer_scene_select].d_name[0] == '.') {
				// ǥ쥯ȥ̾ 2 ХܤɥåȤ
				if(current_dirents[filer_scene_select].d_name[1] == '.') {
					// ߤΥǥ쥯ȥѹ롣(ƥǥ쥯ȥ)
					current_directory[strlen(current_directory) - 1] = '\0';
					*(strrchr(current_directory, '/') + 1) = '\0';
				}
			} else {
				// ߤΥǥ쥯ȥѹ롣(̾Υǥ쥯ȥ)
				strcat(current_directory, current_dirents[filer_scene_select].d_name);
				strcat(current_directory, "/");
			}
			
			// ǥ쥯ȥ򹹿롣
			set_dirents();
			// ɽǥå
			filer_scene_index  = 0;
			// 򥤥ǥå
			filer_scene_select = 0;
			// ̤򹹿롣
			filer_draw();
		} else {
			// PSF եΥѥ롣
			strcpy(current_psf_path, current_directory);
			strcat(current_psf_path, current_dirents[filer_scene_select].d_name);
			
			// դ򳫻Ϥ롣˳Ϥ줿
			if(psf_play() >= 0) {
				// ߤΥֱաפꡣ
				current_scene = SCENE_PLAY;
				// ̤򹹿롣
				play_draw();
			}
		}
	// ܥ󤬲줿
	} else if(buttons & PSP_CTRL_TRIANGLE) {
		// С֤ͭ / ̵ڤؤ롣
		enable_reverb ^= 1;
		// ̤򹹿롣
		filer_draw();
	}
}

// ---------------------------------------------------------------------------
// filer_scene_remote
//
// ե̤Υ롼׽
//
//  :
//   buttons : Ƥܥ
//
//  :
//   ̵
// ---------------------------------------------------------------------------
static void filer_scene_remote(u32 buttons)
{
	#define PSP_HPRM_VOL_UP_DOWN 0x30
	int i = 0; // ѿ
	
	// ܥ󤬲줿
	if(buttons & (PSP_HPRM_FORWARD | PSP_HPRM_BACK)) {
		// ܥ˱ư̤롣
		if(buttons & PSP_HPRM_BACK) {
			// 1 ǥåذư
			i = -1;
		} else if(buttons & PSP_HPRM_FORWARD) {
			// 1 ǥåذư
			i = 1;
		}
		
		// 򥤥ǥåư롣
		filer_scene_select += i;
		
		// 򥤥ǥåեƱ礭ʤä
		if(filer_scene_select >= current_dirents_count) {
			// 򥤥ǥå򥯥åפ롣
			filer_scene_select = current_dirents_count - 1;
		// 򥤥ǥå 0 꾮ʤä
		} else if(filer_scene_select < 0) {
			// 򥤥ǥå򥯥åפ롣
			filer_scene_select = 0;
		}
		
		// ɽǥå򥤥ǥå礭ʤä
		if(filer_scene_index > filer_scene_select) {
			// ɽǥåư롣
			filer_scene_index += i;
			
			// ɽǥå 0 꾮ʤä
			if(filer_scene_index < 0) {
				// ɽǥå򥯥åפ롣
				filer_scene_index = 0;
			}
		// ɽǥå + 30 򥤥ǥåƱʤä
		} else if(filer_scene_index + 30 <= filer_scene_select) {
			// ɽǥåư롣
			filer_scene_index += i;
			
			// ɽǥå + 30 եƱ礭ʤä
			if(filer_scene_index + 30 >= current_dirents_count) {
				// ɽǥå򥯥åפ롣
				filer_scene_index = current_dirents_count - 30;
			}
		}
		
		// ̤򹹿롣
		filer_draw();
	// ܥ󤬲줿
	} else if(buttons & PSP_HPRM_PLAYPAUSE) {
		// ǥ쥯ȥ꤫
		if(FIO_SO_ISDIR(current_dirents[filer_scene_select].d_stat.st_attr)) {
			// ǥ쥯ȥ̾ 1 ХܤɥåȤ
			if(current_dirents[filer_scene_select].d_name[0] == '.') {
				// ǥ쥯ȥ̾ 2 ХܤɥåȤ
				if(current_dirents[filer_scene_select].d_name[1] == '.') {
					// ߤΥǥ쥯ȥѹ롣(ƥǥ쥯ȥ)
					current_directory[strlen(current_directory) - 1] = '\0';
					*(strrchr(current_directory, '/') + 1) = '\0';
				}
			} else {
				// ߤΥǥ쥯ȥѹ롣(̾Υǥ쥯ȥ)
				strcat(current_directory, current_dirents[filer_scene_select].d_name);
				strcat(current_directory, "/");
			}
			
			// ǥ쥯ȥ򹹿롣
			set_dirents();
			// ɽǥå
			filer_scene_index  = 0;
			// 򥤥ǥå
			filer_scene_select = 0;
			// ̤򹹿롣
			filer_draw();
		} else {
			// PSF եΥѥ롣
			strcpy(current_psf_path, current_directory);
			strcat(current_psf_path, current_dirents[filer_scene_select].d_name);
			
			// դ򳫻Ϥ롣˳Ϥ줿
			if(psf_play() >= 0) {
				// ߤΥֱաפꡣ
				current_scene = SCENE_PLAY;
				// ̤򹹿롣
				play_draw();
			}
		}
	// ܥ󤬲줿
	} else if(buttons & PSP_HPRM_VOL_UP_DOWN) {
		// С֤ͭ / ̵ڤؤ롣
		enable_reverb ^= 1;
		// ̤򹹿롣
		filer_draw();
	}
}

// ---------------------------------------------------------------------------
// play_scene
//
// ղ̤Υ롼׽
//
//  :
//   buttons : Ƥܥ
//
//  :
//   ̵
// ---------------------------------------------------------------------------
static void play_scene(int buttons)
{
	// ܥ󤬲줿
	if(buttons & PSP_CTRL_CROSS) {
		// դߤ롣
		psf_stop();
		// ߤΥ֥եפꡣ
		current_scene = SCENE_FILER;
		// ̤򹹿롣
		filer_draw();
	// ܥ󤬲줿
	} else if(buttons & PSP_CTRL_SELECT) {
		if( enable_shuffle == 0)
			enable_shuffle = 1;
		else
			enable_shuffle = 0;

		play_draw();
	} else if(buttons & PSP_CTRL_START) {
	
		srand(time(NULL));
		filer_scene_select = rand() % current_dirents_count-1;
			psf_stop();
			filer_scene_index = filer_scene_select;
			strcpy(current_psf_path, current_directory);
			strcat(current_psf_path, current_dirents[filer_scene_select].d_name);
				if(psf_play() >= 0) {
				// ߤΥֱաפꡣ
				current_scene = SCENE_PLAY;
				// ̤򹹿롣
				play_draw();
			}

	} else if(buttons & PSP_CTRL_SQUARE)
		//printf_line(0,"r:%d", scePowerGetCpuClockFrequencyInt());
		printf_line(0,"cpu:%d bus:%d", scePowerGetCpuClockFrequencyInt(),scePowerGetBusClockFrequencyInt());
	else if(buttons & PSP_CTRL_TRIANGLE) {
		// С֤ͭ / ̵ڤؤ롣
		enable_reverb ^= 1;
		// ̤򹹿롣
		play_draw();
	} else if(buttons & PSP_CTRL_LTRIGGER) {
		if(enable_shuffle == 1)
		{
					srand(time(NULL));
		filer_scene_select = rand() % current_dirents_count-1;
			psf_stop();
			filer_scene_index = filer_scene_select;

			strcpy(current_psf_path, current_directory);
			strcat(current_psf_path, current_dirents[filer_scene_select].d_name);
				if(psf_play() >= 0) {
				// ߤΥֱաפꡣ
				current_scene = SCENE_PLAY;
				// ̤򹹿롣
				play_draw();
				}
		}
		else
		{
		filer_scene_select--;
		if(filer_scene_select < 2)
		{
			filer_scene_select = 2;
		}
		else
		{
			psf_stop();
			
			strcpy(current_psf_path, current_directory);
			strcat(current_psf_path, current_dirents[filer_scene_select].d_name);
			if(filer_scene_index > filer_scene_select) {
			filer_scene_index -= 1;

				if(filer_scene_index < 0) 
				{
					filer_scene_index = 0;
				}
			}
			// դ򳫻Ϥ롣˳Ϥ줿
			if(psf_play() >= 0) {
				// ߤΥֱաפꡣ
				current_scene = SCENE_PLAY;
				// ̤򹹿롣
				play_draw();
			}
		}
		}
	} else if(buttons & PSP_CTRL_RTRIGGER) {
		if(enable_shuffle == 1)
		{
					srand(time(NULL));
		filer_scene_select = rand() % current_dirents_count-1;
			psf_stop();
			filer_scene_index = filer_scene_select;

			strcpy(current_psf_path, current_directory);
			strcat(current_psf_path, current_dirents[filer_scene_select].d_name);
				if(psf_play() >= 0) {
				// ߤΥֱաפꡣ
				current_scene = SCENE_PLAY;
				// ̤򹹿롣
				play_draw();
				}
		}
		else
		{
			filer_scene_select++;
			if(filer_scene_select >= current_dirents_count)
			{
				filer_scene_select = current_dirents_count - 1;
			}
			else
			{
			psf_stop();
			strcpy(current_psf_path, current_directory);
			strcat(current_psf_path, current_dirents[filer_scene_select].d_name);
			if(filer_scene_index < filer_scene_select) {
			filer_scene_index += 1;	
			}
			// դ򳫻Ϥ롣˳Ϥ줿
			if(psf_play() >= 0) {
				// ߤΥֱաפꡣ
				current_scene = SCENE_PLAY;
				// ̤򹹿롣
				play_draw();
			
				}
			}
		}
	} else if(buttons & PSP_CTRL_CIRCLE) {
		if(thread_paused == 0)
		{
			sceKernelSuspendThread(sexy_thread_id);
			sceKernelSuspendThread(audio_thread_id);
		//	printf_line(1,"paused");
			scePowerSetCpuClockFrequency(33);
			scePowerSetBusClockFrequency(33);
			thread_paused = 1;

		}
		else if(thread_paused == 1)
		{
			scePowerSetCpuClockFrequency(333);
			scePowerSetBusClockFrequency(166);
			sceKernelResumeThread(sexy_thread_id);
			sceKernelResumeThread(audio_thread_id);
		//	printf_line(1,"unpaused");
			thread_paused = 0;
		}
		play_draw();
	}

}

// ---------------------------------------------------------------------------
// play_scene_remote
//
// ղ̤Υ롼׽
//
//  :
//   buttons : Ƥܥ
//
//  :
//   ̵
// ---------------------------------------------------------------------------
static void play_scene_remote(u32 buttons)
{
#define PSP_HPRM_VOL_UP_DOWN 0x30
	// ܥ󤬲줿
	if(buttons & PSP_HPRM_PLAYPAUSE) {
		//printf_line(2,"thread:%d", thread_paused);
		if(thread_paused == 0)
		{
			sceKernelSuspendThread(sexy_thread_id);
			sceKernelSuspendThread(audio_thread_id);
			
			scePowerSetCpuClockFrequency(33);
			scePowerSetBusClockFrequency(33);
		//	printf_line(1,"paused");
			thread_paused = 1;

		}
		else if(thread_paused == 1)
		{
			scePowerSetCpuClockFrequency(333);
			scePowerSetBusClockFrequency(166);
			sceKernelResumeThread(sexy_thread_id);
			sceKernelResumeThread(audio_thread_id);
		//	printf_line(1,"unpaused");
			thread_paused = 0;
		}
	//		printf_line(0," ");

		play_draw();
		/*// դߤ롣
		psf_stop();
		// ߤΥ֥եפꡣ
		current_scene = SCENE_FILER;
		// ̤򹹿롣
		filer_draw();
	// ܥ󤬲줿*/
	} else if(buttons == 48) {//& PSP_HPRM_VOL_UP_DOWN) {
				// С֤ͭ / ̵ڤؤ롣
		enable_reverb ^= 1;
		// ̤򹹿롣
		play_draw();
		
	}	else if(buttons & PSP_HPRM_FORWARD) {
		if(enable_shuffle == 1)
		{
					srand(time(NULL));
		filer_scene_select = rand() % current_dirents_count-1;
					filer_scene_index = filer_scene_select;

			psf_stop();
			strcpy(current_psf_path, current_directory);
			strcat(current_psf_path, current_dirents[filer_scene_select].d_name);
				if(psf_play() >= 0) {
				// ߤΥֱաפꡣ
				current_scene = SCENE_PLAY;
				// ̤򹹿롣
				play_draw();
				}
		}
		else
		{

			filer_scene_select++;
			if(filer_scene_select >= current_dirents_count)
			{
				filer_scene_select = current_dirents_count - 1;
			}
			else
			{
			psf_stop();
			strcpy(current_psf_path, current_directory);
			strcat(current_psf_path, current_dirents[filer_scene_select].d_name);
			if(filer_scene_index < filer_scene_select) {
			filer_scene_index += 1;		
			}
			// դ򳫻Ϥ롣˳Ϥ줿
			if(psf_play() >= 0) {
				// ߤΥֱաפꡣ
				current_scene = SCENE_PLAY;
				// ̤򹹿롣
				play_draw();
			
			}
			}
		}
	} else if(buttons & PSP_HPRM_BACK) {
		if(enable_shuffle == 1)
		{
					srand(time(NULL));
		filer_scene_select = rand() % current_dirents_count-1;
			psf_stop();
						filer_scene_index = filer_scene_select;

			strcpy(current_psf_path, current_directory);
			strcat(current_psf_path, current_dirents[filer_scene_select].d_name);
				if(psf_play() >= 0) {
				// ߤΥֱաפꡣ
				current_scene = SCENE_PLAY;
				// ̤򹹿롣
				play_draw();
				}
		}
		else
		{
			filer_scene_select--;
		if(filer_scene_select < 2)
		{
			filer_scene_select = 2;
		}
		else
		{
			psf_stop();
			strcpy(current_psf_path, current_directory);
			strcat(current_psf_path, current_dirents[filer_scene_select].d_name);
			if(filer_scene_index > filer_scene_select) {

				filer_scene_index -= 1;
			
				if(filer_scene_index < 0) 
				{

					filer_scene_index = 0;
				}
			}
			// դ򳫻Ϥ롣˳Ϥ줿
			if(psf_play() >= 0) {
				// ߤΥֱաפꡣ
				current_scene = SCENE_PLAY;
				// ̤򹹿롣
				play_draw();
			}
		}
		}
	}
}

// ---------------------------------------------------------------------------
// exit_callback
//
// λХå
//
//  :
//   ̵
//
//  :
//    0
// ---------------------------------------------------------------------------
static int exit_callback()
{
	// դߡ
	psf_stop();
	
	// եȥνλ
	sceKernelExitGame();
	
	// ｪλ
	return 0;
}

// ---------------------------------------------------------------------------
// power_callback
//
// ŸХå
//
//  :
//   unknown   : ̤ѡ
//   powerInfo : ̤ѡ
//
//  :
//   ̵
// ---------------------------------------------------------------------------
static void power_callback(int unknown, int powerInfo)
{
}

// ---------------------------------------------------------------------------
// callback_thread
//
// Υåɡ
//
//  :
//   args : ̤ѡ
//   argp : ̤ѡ
//
//  :
//    0
// ---------------------------------------------------------------------------
static int callback_thread(SceSize args, void *argp)
{
	int exit_callback_id;  // λХå ID
	int power_callback_id; // ŸХå ID
	
	// λХåϿ
	exit_callback_id = sceKernelCreateCallback("Exit Callback", exit_callback, 0);
	sceKernelRegisterExitCallback(exit_callback_id);
	
	// ŸХåϿ
	power_callback_id = sceKernelCreateCallback("Power Callback", power_callback, 0);
	scePowerRegisterCallback(0, power_callback_id);
	
	// åɤ򥹥꡼פ롣
	sceKernelSleepThreadCB();
	
	// ｪλ
	return 0;
}

// ---------------------------------------------------------------------------
// main
//
// ᥤ
//
//  :
//   argc : ̤ѡ
//   argv : ̤ѡ
//
//  :
//    0
// ---------------------------------------------------------------------------
int main(int argc, char *argv[])
{
	int callback_thread_id; // Υåɤ ID
	SceCtrlData ctrl_data;  // ȥ顼ξ֡
	int buttons_prev;       // Υܥξ֡
	u32 remoteButtons, remoteButtonsOld = 0;
	
	// Υåɤȳϡ
	
	callback_thread_id = sceKernelCreateThread("update_thread", callback_thread, 17, 4000, 0, 0);
	sceKernelStartThread(callback_thread_id, 0, 0);
	

	
	// ǥХå꡼ν
	pspDebugScreenInit();
	//pspDebugInstallErrorHandler(NULL);
	// ȥ顼Υץ󥰥ȥ⡼ɤꡣ
	sceCtrlSetSamplingCycle(0);
	sceCtrlSetSamplingCycle(PSP_CTRL_MODE_DIGITAL);
	
	// PSFINFO ¤Τν
	psf_info      = 0;
	// С̵֤ˤ롣
	enable_reverb = 0;
	// Υܥξ֤
	buttons_prev  = 0;
	
	// ߤΥ֥եפꡣ
	current_scene = SCENE_FILER;
	// ߤΥǥ쥯ȥms0:/פꡣ
	strcpy(current_directory, "ms0:/");
	// ǥ쥯ȥ򹹿롣
	set_dirents();
	// ɽǥå
	filer_scene_index  = 0;
	// 򥤥ǥå
	filer_scene_select = 0;
	// ̤򹹿롣
	filer_draw();
	
	// ᥤ롼ס
	while(1)
	{

		// ȡ(100 ms)
		sceKernelDelayThread(100000);
		
		// ȥ顼ξ֤
		sceCtrlReadBufferPositive(&ctrl_data, 1);
		
		// ȲƤܥξ֤Ʊ
		if(ctrl_data.Buttons == buttons_prev) {
			// ܥʳϲƤʤΤȤ롣
			ctrl_data.Buttons &= (PSP_CTRL_UP | PSP_CTRL_RIGHT | PSP_CTRL_DOWN | PSP_CTRL_LEFT);
		} else {
			// ߤΥܥξ֤¸롣
			buttons_prev = ctrl_data.Buttons;
		}
		
		// ߤΥ˱ؿƤӽФ
		switch(current_scene)
		{
		case SCENE_FILER:
			{	// ե
			filer_scene(ctrl_data.Buttons);
				remoteButtonsOld = remoteButtons;
				sceHprmPeekCurrentKey(&remoteButtons);
			//	printf_line(0,"r:%d", remoteButtons);
				if (remoteButtons != remoteButtonsOld && !(remoteButtons & PSP_HPRM_HOLD))
				{
					filer_scene_remote(remoteButtons);
				}
			break;
			}
		case SCENE_PLAY:
			{
			// ա
				//used to count time and show
			sceRtcGetCurrentTick(&current_tick);
			if(current_tick-start_cputicks >= sceRtcGetTickResolution())
			{
				sceRtcGetCurrentTick(&start_cputicks);
				if(thread_paused == 0)
				{
					seconds += 1;
					if(seconds >= 60)
					{
						minutes += 1;
						seconds = 0;
						if(minutes >= 60)
						{					
							hours +=1;//ok, i know, this *can* overflow but i think the psp burn before this happens XD
							minutes = 0;
						}
					}
				}
			}
			printf_line(31, "%3d:%2d:%2d",hours,minutes,seconds);

			play_scene(ctrl_data.Buttons);
			//if (sceHprmIsRemoteExist > 0)
			//{
				remoteButtonsOld = remoteButtons;
				sceHprmPeekCurrentKey(&remoteButtons);
			//	printf_line(0,"r:%d", remoteButtons);
				if (remoteButtons != remoteButtonsOld && !(remoteButtons & PSP_HPRM_HOLD))
				{
					play_scene_remote(remoteButtons);
			//		printf_line(0,"r:%d", remoteButtons);
			
				}
			//}
			}
		}
	}
	
	// ｪλ
	return 0;
}
